/* gjid03.c                         freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void DeterA(int n)
{
complexF z_det;

double pbA   [MXR][MXC*C4];mzF mA   ={MXR,MXC*C4,&pbA   [0][0]};
double pbinvA[MXR][MXC*C4];mzF minvA={MXR,MXC*C4,&pbinvA[0][0]};
double pbid  [MXR][MXC*C4];mzF mid  ={MXR,MXC*C4,&pbid  [0][0]};

                     mA.rows=n;                   mA.cols= n*C4;
                  minvA.rows=n;                minvA.cols= n*C4;
                    mid.rows=n;                  mid.cols= n*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
   if(n==4) rnd0_mzF(&mA,2,2);
   if(n==3) rnd0_mzF(&mA,3,2);
   if(n==2) rnd0_mzF(&mA,4,4);
   if(n==1) rnd0_mzF(&mA,5,5);

   z_det = det_zF(&mA);

  }while( (!z_det.r.n) && (!z_det.i.n));

  clrscrn();
  printf("     A\n");
  p_mizF3(&mA);

  printf(" inv(A)\n");
  inverse_mzF(&mA,&minvA);
  p_mizF3(&minvA);

  mul_mzF(&mA,&minvA,&mid);
  p_mizF(&mid);

}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n                 inverse(mA)                      ");
  printf("\n                 ***********                    \n");
  printf("\n The size of mA : 2x2 ... 5x5.                  \n");
  printf("\n           ex : \"inverse.exe\"                 \n");
  printf("\n You can choose the size :                      \n");
  printf("\n           ex : \"inverse.exe 2\" -> mA 2x2       ");
  printf("\n                \"inverse.exe 3\" -> mA 3x3       ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                          ");
  printf("\n                                                  ");

  getchar();
}

/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 2 && atoi(argv[1]))
 {  n = atoi(argv[1]); if( n > 4){n=4;}}
else
 {  n = rndp_I(4);}
if( n < 1){n=1;}


  DeterA(n);


printf("\n\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

