/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void TrpsA(int n,int p)
{
double pbA    [MXR][MXC*C4];mzF mA    ={MXR,MXC*C4,&pbA    [0][0]};
double pbTrpsA[MXR][MXC*C4];mzF mTrpsA={MXR,MXC*C4,&pbTrpsA[0][0]};

                     mA.rows=n;                   mA.cols=p*C4;
                 mTrpsA.rows=p;               mTrpsA.cols=n*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
  rnd_mzF(&mA,9,9);

  clrscrn();
  printf("                                                       A :\n");
  p_mizF(&mA);
  getchar();

  cnj_transpose_mzF(&mA,&mTrpsA);

  printf("                                      cnj_transpose(mA) :\n");
  p_mizF(&mTrpsA);
}


void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n      Conjugate Transpose of mA                   ");
  printf("\n      *************************                 \n");
  printf("\n The size of mA : 1x1 ... 4x4.                  \n");
  printf("\n     ex : \"trpFR.exe\"                         \n");
  printf("\n You can choose the size :                      \n");
  printf("\n     ex : \"trpFR.exe 2 3\" -> 2x3                ");
  printf("\n          \"trpFR.exe 4 4\" -> 4x4                ");
  printf("\n          \"trpFR.exe 1 4\" -> 1x4                ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");
  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;
int    p;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 3 && atoi(argv[1])&& atoi(argv[2]))
 {n = atoi(argv[1]); if( n > 4){n=4;}
  p = atoi(argv[2]); if( p > 4){p=4;}}
else
 {    n=rndp_I(4);       p=rndp_I(4); }
   if(n<1){n=1;}     if(p<1){p=1;}


  TrpsA(n,p);


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}












