/* xrndm.h                    free ware                    xhunga@tiscali.fr  */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_mzF(
PmzF mA,
int     maxn,
int     maxd)
{
fraction f;
int      i;
int      j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += 4)
       {
        f = rnd_F(maxn,maxd);
        *(mA->pb+i *mA->cols+j  ) = f.n;
        *(mA->pb+i *mA->cols+j+1) = f.d;

        f = rnd_F(maxn,maxd);
        *(mA->pb+i *mA->cols+j+2) = f.n;
        *(mA->pb+i *mA->cols+j+3) = f.d;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd0_mzF(
PmzF mA,
int     maxn,
int     maxd)
{
fraction f;
int      i;
int      j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += 4)
       {
        f = rnd0_F(maxn,maxd);
        *(mA->pb+i *mA->cols+j  ) = f.n;
        *(mA->pb+i *mA->cols+j+1) = f.d;

        f = rnd0_F(maxn,maxd);
        *(mA->pb+i *mA->cols+j+2) = f.n;
        *(mA->pb+i *mA->cols+j+3) = f.d;
       }
}



/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_mzI(
PmzF mA,
int     maxn)
{
int i;
int j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += 4)
       {
        *(mA->pb+i *mA->cols+j)   = rnd_I(maxn);
        *(mA->pb+i *mA->cols+j+1) = 1;
        *(mA->pb+i *mA->cols+j+2) = rnd_I(maxn);
        *(mA->pb+i *mA->cols+j+3) = 1;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd0_mzI(
PmzF mA,
int     maxn)
{
int i;
int j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += 4)
       {
        *(mA->pb+i *mA->cols+j)   = rnd0_I(maxn);
        *(mA->pb+i *mA->cols+j+1) = 1;
        *(mA->pb+i *mA->cols+j+2) = rnd0_I(maxn);
        *(mA->pb+i *mA->cols+j+3) = 1;
       }
}

