/* gjid03.c                         freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void DeterA(int n)
{
complexF z_det;

double pbA [n][n*C4];mzF mA ={n,n*C4,&pbA [0][0]};
double pbU [n][n*C4];mzF mU ={n,n*C4,&pbU [0][0]};
double pbL [n][n*C4];mzF mL ={n,n*C4,&pbL [0][0]};
double pbLU[n][n*C4];mzF mLU={n,n*C4,&pbLU[0][0]};

                     mA.rows=n;                   mA.cols=n*C4;
                     mU.rows=n;                   mU.cols=n*C4;
                     mL.rows=n;                   mL.cols=n*C4;
                    mLU.rows=n;                  mLU.cols=n*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
   if(n==4) rnd_mzF(&mA,2,1);
   if(n==3) rnd_mzF(&mA,2,2);
   if(n==2) rnd_mzF(&mA,4,4);

   z_det = det_zF(&mA);

  }while( (!z_det.r.n) && (!z_det.i.n));

  clrscrn();

  printf("  A :");
  p_mizF(&mA);

  LU_mzF( &mA,&mL, &mU);
  printf("  L :");
  p_mizF(&mL);

  printf("  U :");
  p_mizF(&mU);

  mul_mzF(&mL,&mU,&mLU);
  printf(" LU :");
  p_mizF(&mLU);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n            LU decomposition.                     ");
  printf("\n            ****************                    \n");
  printf("\n The size of mA : 2x2 ... 4x4.                  \n");
  printf("\n           ex : \"LUFR.exe\"                    \n");
  printf("\n You can choose the size :                      \n");
  printf("\n           ex : \"LUFR.exe 2\" -> mA 2x2          ");
  printf("\n                \"LUFR.exe 3\" -> mA 3x3          ");
  printf("\n                \"LUFR.exe 4\" -> mA 4x4          ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}

/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 2 && atoi(argv[1]))
 {  n = atoi(argv[1]); if( n > 4){n=4;}}
else
 {  n = rndp_I(4);}
if( n < 2){n=2;}


  DeterA(n);


printf("\n\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

