/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void AplsB(int n,int p)
{
double pbA    [MXR][MXC*C4];mzF mA    ={MXR,MXC*C4,&pbA    [0][0]};
double pbB    [MXR][MXC*C4];mzF mB    ={MXR,MXC*C4,&pbB    [0][0]};
double pbAplsB[MXR][MXC*C4];mzF mAplsB={MXR,MXC*C4,&pbAplsB[0][0]};

                     mA.rows=n;                   mA.cols=p*C4;
                     mB.rows=n;                   mB.cols=p*C4;
                 mAplsB.rows=n;               mAplsB.cols=p*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
  rnd_mzF(&mA,9,9);
  rnd_mzF(&mB,9,9);

  clrscrn();
  printf("                                                       A :");
  p_mizF(&mA);
  printf("                                                       B :");
  p_mizF(&mB);
  getchar();

  add_mzF(&mA,&mB,&mAplsB);

  printf("                                                       A + B :");
  p_mizF(&mAplsB);
}


void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n            Add two complex matrices              ");
  printf("\n            ************************            \n");
  printf("\n The size of mA, mB, mAB : 1x1 ... 6x4.         \n");
  printf("\n     ex : \"addmFR.exe\"                        \n");
  printf("\n You can choose the size :                      \n");
  printf("\n     ex : \"addmFR.exe 2 3\" -> 2x3               ");
  printf("\n          \"addmFR.exe 6 4\" -> 6x4               ");
  printf("\n          \"addmFR.exe 1 4\" -> 1x4               ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");
  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;
int    p;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 3 && atoi(argv[1])&& atoi(argv[2]))
 {n = atoi(argv[1]); if( n > 6){n=6;}
  p = atoi(argv[2]); if( p > 4){p=4;}}
else
 {    n=rndp_I(6);       p=rndp_I(4); }
   if(n<1){n=1;}     if(p<1){p=1;}


  AplsB(n,p);


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}












