/* gjid03.c                         free ware                  xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gjA(int n)
{
double pbA    [MXR][MXC*C4];mzF mA    ={MXR,MXC*C4,&pbA    [0][0]};

                     mA.rows=n;      mA.cols=(n+1)*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
   if(n==4) rnd0_mzF(&mA,2,1);
   if(n==3) rnd0_mzF(&mA,2,1);
   if(n==2) rnd0_mzF(&mA,3,2);

  clrscrn();
  printf(" A ");
  p_mizF3(&mA);

  printf("\n\n GaussJordan elimination of matrix mA \n");
  gaussjordan_mzF(&mA);
  p_mizF3(&mA);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n            GaussJordan elimination               ");
  printf("\n            ***********************             \n");
  printf("\n The size of mA : 2x3 ... 4x5.                  \n");
  printf("\n           ex : \"gjf.exe\"                     \n");
  printf("\n You can choose the size :                      \n");
  printf("\n           ex : \"gjf.exe 2\" -> mA 2x3           ");
  printf("\n                \"gjf.exe 3\" -> mA 3x4           ");
  printf("\n                \"gjf.exe 4\" -> mA 4x5           ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                          ");
  printf("\n                                                  ");

  getchar();
}

/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 2 && atoi(argv[1]))
 {  n = atoi(argv[1]); if( n > 4){n=4;}}
else
 {  n = rndp_I(4);}
if( n < 2){n=2;}


  gjA(n);


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

