/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "y_ahfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void AmnsB(int n,int p)
{
double pbA    [MXR][MXC*C4];mzF mA    ={MXR,MXC*C4,&pbA    [0][0]};
double pbB    [MXR][MXC*C4];mzF mB    ={MXR,MXC*C4,&pbB    [0][0]};
double pbAmnsB[MXR][MXC*C4];mzF mAmnsB={MXR,MXC*C4,&pbAmnsB[0][0]};

                     mA.rows=n;                   mA.cols=p*C4;
                     mB.rows=n;                   mB.cols=p*C4;
                 mAmnsB.rows=n;               mAmnsB.cols=p*C4;
/*-------------------------------- PROGRAM ---------------------------------- */
  rnd_mzF(&mA,9,9);
  rnd_mzF(&mB,9,9);

  clrscrn();
  printf("                                                       A :");
  p_mizF(&mA);
  printf("                                                       B :");
  p_mizF(&mB);
  getchar();

  sub_mzF(&mA,&mB,&mAmnsB);

  printf("                                                       A - B :");
  p_mizF(&mAmnsB);
}


void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n                                                  ");
  printf("\n            Subtrac two complex matrices          ");
  printf("\n            ****************************        \n");
  printf("\n The size of mA, mB, mAB : 1x1 ... 6x4.         \n");
  printf("\n     ex : \"submFR.exe\"                        \n");
  printf("\n You can choose the size :                      \n");
  printf("\n     ex : \"submFR.exe 2 3\" -> 2x3               ");
  printf("\n          \"submFR.exe 6 4\" -> 6x4               ");
  printf("\n          \"submFR.exe 1 4\" -> 1x4               ");
  printf("\n\n                                                ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");
  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;
int    p;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 3 && atoi(argv[1])&& atoi(argv[2]))
 {n = atoi(argv[1]); if( n > 6){n=6;}
  p = atoi(argv[2]); if( p > 4){p=4;}}
else
 {    n=rndp_I(6);       p=rndp_I(4); }
   if(n<1){n=1;}     if(p<1){p=1;}


  AmnsB(n,p);


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}












