/* .h                          free ware                   xhunga@tiscali.fr  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexF innerprod_zF(
PmzF mu,
PmzF mv
)
{
complexF InnerProduct;

  if (mu->rows == 1             &&
      mu->cols == mv->rows * C4 &&
      mv->cols == C4
     )
     {
      InnerProduct = uv_uv_zF(mu,mv);
     }
    else if
     (mu->rows == 1        &&
      mv->rows == 1        &&
      mu->cols == mv->cols
     )
     {
      InnerProduct = uv_uvT_zF(mu,mv);
     }
    else if
     (mu->rows == mv->rows &&
      mu->cols == mv->cols &&
      mu->cols == C4
     )
     {
      InnerProduct = uv_uTv_zF(mu,mv);
     }
    else if
     (mu->rows * C4 == mv->cols &&
      mu->cols      == C4   &&
      mv->rows      == 1
     )
     {
      InnerProduct = uv_uTvT_zF(mu,mv);
     }
     else
     {
      printf(" innerprod() error.\n\n");

      printf("\nPress Return to continue\n");
      getchar();
      exit(1);
     }


  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexF normP2_zF(
PmzF mu
)
{
complexF NormP2;

         NormP2 = innerprod_zF(mu,mu);

  return(NormP2);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexF distanceP2_zF(
PmzF mu,
PmzF mv
)
{
complexF DistanceP2;

double pu_mns_v [MXR][MXC*C4];mzF mu_mns_v={MXR, MXC*C4,&pu_mns_v[0][0]};

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

      sub_mzF(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_zF(&mu_mns_v);

  return(DistanceP2);
}

